image: ralfjung/opam-ci:opam2

stages:
  - build

variables:
  CPU_CORES: "10"

.template: &template
  stage: build
  tags:
  - fp
  script:
  - git clone https://gitlab.mpi-sws.org/iris/ci.git ci -b opam2
  - ci/buildjob
  cache:
    key: "$CI_JOB_NAME"
    paths:
    - _opam/
  only:
  - /^master/@iris/iris
  - /^ci/@iris/iris
  except:
  - triggers
  - schedules
  - api

## Build jobs

build-coq.dev:
  <<: *template
  variables:
    OPAM_PINS: "coq version dev"
    MANGLE_NAMES: "1"

build-coq.8.13.2:
  <<: *template
  variables:
    OPAM_PINS: "coq version 8.13.2"
    DENY_WARNINGS: "1"
    OPAM_PKG: "1"
    DOC_DIR: "coqdoc@center.mpi-sws.org:iris"
    DOC_OPTS: "--external https://plv.mpi-sws.org/coqdoc/stdpp/ stdpp"
  tags:
  - fp-timing

build-coq.8.12.2:
  <<: *template
  variables:
    OPAM_PINS: "coq version 8.12.2"
    DENY_WARNINGS: "1"

# Nightly job with a known-to-work Coq version
# (so failures must be caused by std++)
build-stdpp.dev-coq.8.13.1:
  <<: *template
  variables:
    OPAM_PINS: "coq version 8.13.1   coq-stdpp.dev git git+https://gitlab.mpi-sws.org/iris/stdpp.git#$STDPP_REV"
  except:
  only:
  - triggers
  - schedules
  - api

# Nightly job with latest Coq beta branch
build-stdpp.dev-coq.8.13.dev:
  <<: *template
  variables:
    OPAM_PINS: "coq version 8.13.dev   coq-stdpp.dev git git+https://gitlab.mpi-sws.org/iris/stdpp.git#$STDPP_REV"
    CI_COQCHK: "1"
  except:
  only:
  - triggers
  - schedules
  - api
